#include "t_services.h"
#include "kernel_id.h"
#include "complex_ssb.h"
#include "ad1836a.h"
#include "stk.h"

#define TAPS 256

static short sound[SAMPLE_PER_INTR], signal[SAMPLE_PER_INTR], sp[SAMPLE_PER_INTR];
static short temp_r[SAMPLE_PER_INTR], temp_i[SAMPLE_PER_INTR];
static short temp2_r[SAMPLE_PER_INTR], temp2_i[SAMPLE_PER_INTR];
static short lo_r[SAMPLE_PER_INTR], lo_i[SAMPLE_PER_INTR];


static short re_coeff[TAPS]={
	#include "relpf.txt"
};
static short im_coeff[TAPS]={
	#include "imlpf.txt"
};
static struct CODEC_BUFFER tx_buf;


void modem_task(VP_INT extinf)
{
	struct CODEC_BUFFER * rx_buf;
	
		// ϒ̕ftB^
	stk::CFilter * mod_re_fir = new stk::CFirFilter( re_coeff, TAPS );
	stk::CFilter * mod_im_fir = new stk::CFirFilter( im_coeff, TAPS );
		// ̕ftB^
	stk::CFilter * demod_re_fir = new stk::CFirFilter( re_coeff, TAPS );
	stk::CFilter * demod_im_fir = new stk::CFirFilter( im_coeff, TAPS );
		// 12KHz̋ǔ
	stk::CDDS * lo = new stk::CDDS( 0x40000000 ); // 48KHz/4 = 12KHz
		// 11KHz̖WQg
	stk::CDDS * spurious = new stk::CDDS( 984263339 ); // 2^32 / 48 * 11 = 11 KHz
		

	act_tsk( CODEC_TASK );
	while( 1 )
	{
		int sample, slot;
		
		rcv_dtq( CODEC_RX_DTQ, (VP_INT*)& rx_buf );

				// ̓f[^LRoĉZB
				// SLOT 0 : Internal L
				// SLOT 4 : Internal R
				// 24 bit f[^Z, 16bit
				// ۂ߂邽߂9bitVtg
		for ( sample = 0; sample < SAMPLE_PER_INTR; sample++ )
			sound[sample] = ( rx_buf->data[sample][0] + rx_buf->data[sample][4] ) >> 17;
				// sound ɂ̓mf[^ĂB		


				// ---------- USB ϒ -------------
				// ftB^Kp
		mod_re_fir->run( temp_r, sound, SAMPLE_PER_INTR );
		mod_im_fir->run( temp_i, sound, SAMPLE_PER_INTR );

						// fǔ(͐M)𐶐
		lo->run( lo_r, lo_i, SAMPLE_PER_INTR );
		
				// +12KHz̃AbvRo[g
		stk::mul( temp_r, temp_r, lo_r, SAMPLE_PER_INTR );
		stk::mul( temp_i, temp_i, lo_i, SAMPLE_PER_INTR );
		stk::sub( signal, temp_r, temp_i, SAMPLE_PER_INTR );	
	
				// fǔ(+12KHz ͐M)𐶐
		lo->run( lo_r, lo_i, SAMPLE_PER_INTR );
				// ---------- WQg -------------
				// WQM(11KHz cosg)𐶐
		spurious->run( sp, SAMPLE_PER_INTR );
		stk::mul( sp, sp, 0x4000, SAMPLE_PER_INTR ); // 0.5{
			
				// WQM̍
		stk::add( signal, signal, sp, SAMPLE_PER_INTR );
		
				// ---------- USB  -------------
                // -12KHzŃ_ERo[g
    	stk::mul( temp_r, lo_i, signal, SAMPLE_PER_INTR );    // -12Khzɂ邽߂
    	stk::mul( temp_i, lo_r, signal, SAMPLE_PER_INTR );    // sin/cosւ
 
      	demod_re_fir->run( temp2_r, temp_r, SAMPLE_PER_INTR ); // 
    	demod_im_fir->run( temp2_i, temp_i, SAMPLE_PER_INTR ); // 
 
		stk::sub( sound, temp2_r, temp2_i, SAMPLE_PER_INTR );    // USB
//	  	stk::add( sound, temp2_r, temp2_i, SAMPLE_PER_INTR );    // LSB

		for ( sample = 0; sample < SAMPLE_PER_INTR; sample++ )
		{
			tx_buf.data[sample][0] = sound[sample] << 16;//rx_buf->data[sample][0];
			tx_buf.data[sample][4] = sound[sample] << 16;//rx_buf->data[sample][4];
		}
				// ---------- o̓obt@ɃRs[ -------------
		snd_dtq( CODEC_TX_DTQ, (VP_INT) & tx_buf ); 
	}
}


